#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/ask.c,v 1.1 94/02/01 16:37:11 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/ask.c,v 1.1 94/02/01 16:37:11 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  ask.c - Post a query window

*****************************************************************************/

#include "defs.h"
#include "types.h"
#include "windows.h"
#include "objects.h"

#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/Shell.h>

#include <Xm/PushB.h>
#include <Xm/Form.h>
#include <Xm/Label.h>

/***************************************************
 *
 *	Externals
 *
 */

extern Widget toplevel;

/***************************************************
 *
 *	Local functions...
 *
 */

static void standardCancel();

/***************************************************
 *
 *	Global functions...
 *
 */

void deleteQueryMessage();

/*****************************************************************************
 * postQueryMessage()
 *
 * Post a querying window with a given message and callbacks 
 * for user Cancel or Ok.
 * 
 *
 ****************************************************************************/

void postQueryMessage
  (parent_id, message, want_cancel, call_on_ok, call_on_cancel, data)
     int parent_id;
     String message;
     BOOLEAN want_cancel;
     XtCallbackProc call_on_ok;
     XtCallbackProc call_on_cancel;
     XtPointer data;
{
  XLUwindowObject this_object;
  Widget parent_shell, label, popup_shell, form, ok_button, cancel_button;
  Arg args[MAXARGS];
  int count;
  Position x, y;
  XmString cstr;

  this_object = XLUgetWindowObject(parent_id);

  parent_shell = this_object->parent_shell;
  XtTranslateCoords(parent_shell, -20, 20, &x, &y);

  if (x < 0)
    x = 0;

  XBell(XtDisplay(parent_shell), 40);

  popup_shell = XtCreatePopupShell("Query",
				   transientShellWidgetClass,
				   toplevel,
				   args,
				   0);

  form = XmCreateForm(popup_shell, "messageForm", args, 0);

  
  count = 0;
  cstr = XmStringCreateSimple(message);
  XtSetArg(args[count], XmNlabelString, cstr); count++;
  XtSetArg(args[count], XmNborderWidth, 0); count++;

  label = XmCreateLabel(form, "queryLabel", args, count);
  XmStringFree(cstr);
  
  count = 0;
  XtSetArg(args[count], XmNtopWidget, label); count++;
  ok_button = XmCreatePushButton(form, "queryOkButton", args, count);

  if (call_on_ok == (XtCallbackProc) NULL)
    call_on_ok = standardCancel;

  XtAddCallback(ok_button, XmNactivateCallback, call_on_ok, data);

  if (want_cancel == TRUE)
    {
      count = 0;
      XtSetArg(args[count], XmNtopWidget, label); count++;
      XtSetArg(args[count], XmNleftWidget, ok_button); count++;
      cancel_button = XmCreatePushButton(form,
					  "queryCancelButton",
					  args,
					  count);

      if (call_on_cancel == (XtCallbackProc) NULL)
	call_on_cancel = standardCancel;

      XtAddCallback(cancel_button, XmNactivateCallback, call_on_cancel, data);
    }
  
  XtMoveWidget(popup_shell, x, y);
  XtPopup(popup_shell, XtGrabExclusive);
} /* postUserQuery */

/*****************************************************************************
 * standardCancel()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void standardCancel(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  deleteQueryMessage(w);
} /* standardCancel */

/*****************************************************************************
 * deleteQueryMessage()
 *
 * 
 *
 ****************************************************************************/

void deleteQueryMessage(w)
     Widget w;
{
  Widget shell;

  for (shell = w;
       shell != NULLWidget && XtClass(shell) != transientShellWidgetClass;
       shell = XtParent(shell))
    ;

  if (shell != NULLWidget)
    XtDestroyWidget(shell);
} /* deleteQueryMessage */
