/*****************************************************************************

  layout.h

*****************************************************************************/

#ifndef _Xlu_layout_h_
#define _Xlu_layout_h_

#include "defs.h"
#include "windows.h"

#define MAXTEMPLATES 255
#define MAXMEMBERS 64

typedef struct XLUprimitiveAction
{
  int prim_action_id;
  struct XLUprimitiveAction *next;
} *XLUprimitiveAction;

#define prim_action_alloc() (XLUprimitiveAction) \
	XtNew(struct XLUprimitiveAction)
#define NULLPrimActionList (XLUprimitiveAction) NULL

typedef struct XLUlayoutObject
{
  orientation orient;
  int template_id;

  ReferenceType ref;
  union
    {
      int primitive_id;
      int layout_ref_id;
    } reference;

  struct XLUlayoutObject *next;

  /* Standard properties */
  BOOLEAN expand;
  String bitmap_file;
  String help_file;
  String label;
  String name;

  /* Insensitivity rules */
#define I_DS_WAIT	0x01
#define I_NO_ERROR	0x02
#define I_NO_ENTRY	0x04
#define I_NO_LIST	0x08
#define I_NO_MAIL	0x10
#define I_NORMAL	0x20
  char insensitivity;

  /* Properties for primitives only */
  XLUprimitiveAction action_list;
  Dimension width;
  Dimension height;
} *XLUlayoutObject;

#define NULLLayout (XLUlayoutObject) NULL
#define layout_alloc() (XLUlayoutObject) XtNew(struct XLUlayoutObject)

typedef struct XLUwindowTemplate
{
  String template_name;
  BOOLEAN parsed;
  file_org origin;
  XLUlayoutObject layout;
} *XLUwindowTemplate;

#define NULLTemplate (XLUwindowTemplate) NULL
#define template_alloc() (XLUwindowTemplate) XtNew(struct XLUwindowTemplate)

/***************************************************
 *
 * Global functions..
 *
 */

Widget XLUmakeWindowFromTemplate();
XLUlayoutObject XLUgetPrimitiveTemplate();
WidgetList XLUgetPrimitiveList();
WidgetList findNamedInstances();

#endif /* _Xlu_layout_h_ */


