#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/main.c,v 1.1 94/02/01 16:37:47 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/******************************************************************************
 
  main.c 

******************************************************************************/

/* Errm.. oh dear! Used to load X resources explicitly within application */
#define XLIB_ILLEGAL_ACCESS

#include "defs.h"
#include "windows.h"
#include "objects.h"
#include "interact.h"
#include "widgets.h"
#include "configure.h"
#include "update1.h"
#include "showentry.h"
#include "status.h"

#include "query.h"
#include "init.h"

#include "manifest.h"
#include "tailor.h"

#ifdef USE_PP
#include "or.h"
#endif

#include <varargs.h>

/***************************************************
 *
 * Externals.
 *
 */

extern BOOLEAN testing;

/***************************************************
 *
 * Local functions.
 *
 */

static void read_args();

/***************************************************
 *
 * Public functions.
 *
 */

void quit();
int advise();

/***************************************************
 *
 * Global storage.
 *
 */

Widget toplevel;
XtAppContext app_context;
Display *dpy;
char XLUresfile[LINESIZE];
Atom wm_delete_window;

String resource_class = "MXlookup", program_name = "mxlu";

/*****************************************************************************
 * main()
 *
 * 
 *
 ****************************************************************************/

int main(argc, argv)
     int argc;
     char *argv[];
{
  XrmDatabase readdb = (XrmDatabase) NULL;
  char filename[LINESIZE];
  Cardinal argcount;
  extern char config_directory[];
  
  extern time_t cache_timeout;
  extern BOOLEAN want_photo_as_bytes, want_audio_as_bytes;

  argcount = argc;
  toplevel = XtAppInitialize(&app_context,
			     resource_class, 
			     NULL,
			     0,
			     &argcount, argv,
			     NULL,
			     NULL,
			     0);

  argc = argcount;
  dpy = XtDisplay(toplevel);

  /***************************************************
   *
   * Initialize widget stuff.
   *
   */

  XLUloadActions(app_context);
  wm_delete_window = XInternAtom(dpy, "WM_DELETE_WINDOW", False);

  /***************************************************
   *
   * Get context ids.
   *
   */

  initReadContexts();

  /***************************************************
   *
   * Parse non-DS and non-X arguments
   *
   */

  read_args(argc, argv);

  /***************************************************
   *
   * Initialize DS stuff.
   *
   */

  have_iso8859_font();

  want_photo_as_bytes = TRUE;
  want_audio_as_bytes = TRUE;

  QyInitialize(argc, argv);

  /**************************************************
   *
   * Start async bind.
   * 
   */

  if (QyBindAsync(SIMPLE_AUTH) != QyBindOk)
    {
      XLUpopupMessage("Couldn't bind to directory!");
      exit(1);
    }

  /**************************************************
   *
   * Read XLU configuration.
   * 
   */

  *XLUresfile = '\0';
  user_tailor();
  
  /**************************************************
   *
   * Load core resources.
   * 
   */

  if (testing == FALSE)
    (void) sprintf(filename, "%s/MXlookup.ad", config_directory);
  else
    (void) sprintf(filename, "./MXlookup.ad");
  
  readdb = XrmGetFileDatabase(filename);
  if (readdb != (XrmDatabase) NULL)
    {
      XrmMergeDatabases(readdb, &(dpy->db));
    }

  /**************************************************
   *
   * Load configuration specific resources.
   * 
   */

  if (!isnull(*XLUresfile))
    {
      if (*XLUresfile != '/' && *XLUresfile != '~')
	{
	  (void) sprintf(filename, "%s%s", config_directory, XLUresfile);
	}
      else
	{
	  (void) strcpy(filename, XLUresfile);
	}

      readdb = XrmGetFileDatabase(filename);
      if (readdb != (XrmDatabase) NULL)
	{
	  XrmMergeDatabases(readdb, &(dpy->db));
	}
    }

  /***************************************************
   *
   * Initialize OR stuff.
   *
   */

#ifdef USE_PP
  or_init();
#endif /* USE_PP */

  /***************************************************
   *
   * Set cache timeout for 30 minutes. Should
   * be configurable!
   */

  cache_timeout = 10 * 60;

  /***************************************************
   *
   * Wait for bind to complete.
   *
   */

  if (QyBindAsyncWait(TRUE) != QyBindOk)
    {
      XLUpopupMessage("Couldn't bind to directory!");
      exit(1);
    }

  CreateStartupWindows();

  XLUuserInteract();
  return 0;
} /* main */

/*****************************************************************************
 * read_args()
 *
 * Read command line arguments.
 *
 ****************************************************************************/

static void read_args(argc, argv)
     int argc;
     char *argv[];
{
  char *cp;
  char buf[LINESIZE];

  extern BOOLEAN testing;
  extern char config_file_name[];

  if (argc <= 1)
    return;

  argc--;
  argv++;

  while (argc-- > 0 && ((cp = *argv++) != NULLCP))
    {
      if (*cp == '-')
	{
	  switch (*++cp)
	    {
	    case 'i':
	    case 'I':

	      /**************************************************
	       *
	       * Set ISODE directories.
	       * 
	       */

	      if (argc >= 1)
		{
		  cp = *argv++;
		  
		  if (*cp == '-')
		    xluFatal("Invalid command line syntax.");

		  argc--;
		}
	      else
		xluFatal("Invalid command line syntax.");

	      (void) sprintf(buf, "%s/tmp/", cp);
	      (void) isodesetvar("logpath", strdup(buf), 1);

	      (void) sprintf(buf, "%s/bin/", cp);
	      (void) isodesetvar("binpath", strdup(buf), 1);

	      (void) sprintf(buf, "%s/sbin/", cp);
	      (void) isodesetvar("sbinpath", strdup(buf), 1);

	      (void) sprintf(buf, "%s/etc/", cp);
	      (void) isodesetvar("etcpath", strdup(buf), 1);

/*
	      (void) sprintf(buf, "%s/tmp/", cp);
	      isodelogpath = strdup(buf);

	      (void) sprintf(buf, "%s/bin/", cp);
	      isodebinpath = strdup(buf);

	      (void) sprintf(buf, "%s/sbin/", cp);
	      isodesbinpath = strdup(buf);

	      (void) sprintf(buf, "%s/etc/", cp);
	      isodetcpath = strdup(buf);
*/

	      break;

	    case 'l':
	    case 'L':

	      /**************************************************
	       *
	       * Load a named configuration file.
	       * 
	       */
	      
	      if (argc >= 1)
		{
		  cp = *argv++;
		  
		  if (*cp == '-')
		    xluFatal("Invalid command line syntax.");
		  
		  (void) strcpy(config_file_name, cp);
		  argc--;
		}
	      else
		xluFatal("Invalid command line syntax.");
	      
	      break;
	      
	    case 't':

	      /**************************************************
	       *
	       * Testing prior to installation.
	       * 
	       */
	      
	      if (lexequ(cp, "test") == 0)
		testing = TRUE;
	      
	      default:
	      break;
	    }
	}
    }
} /* read_args */
