#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/requests.c,v 1.1 94/02/01 16:38:04 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/requests.c,v 1.1 94/02/01 16:38:04 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  requests.c - Keep track of requests made and associated input id's.

*****************************************************************************/

/* Bodge to stop /usr/include/time.h unreasonable include nesting! */
#define __time_h

#include "defs.h"

#include "windows.h"
#include "requests.h"
#include "objects.h"
#include "callbacks.h"

#include "showentry.h"
#include "formsrch.h"
#include "update1.h"
#include "update2.h"

/***************************************************
 *
 * Global data.
 *
 */

int XLUrequestCount = 0;
XLUrequestRecord XLUrequestList = NULLXLUrequestRecord;

/***************************************************
 *
 * Externals.
 *
 */

extern XtAppContext app_context;

/***************************************************
 *
 * Local functions.
 *
 */

static void doQueryWork();

/*****************************************************************************
 * XLUrequestComplete()
 *
 * A query engine request has completed. Delete it\'s record structure.
 *
 ****************************************************************************/

void XLUrequestComplete(reqid)
     int reqid;
{
  XLUrequestRecord thisrec, prevrec, currrec;
  int assoc_desc;

  for (thisrec = XLUrequestList, prevrec = NULLXLUrequestRecord;
       thisrec != NULLXLUrequestRecord &&
       thisrec->reqid != reqid;
       prevrec = thisrec, thisrec = thisrec->next)
    ;

  /* This shouldn't happen */
  if (thisrec == NULLXLUrequestRecord)
    return;

  if (prevrec != NULLXLUrequestRecord)
    prevrec->next = thisrec->next;
  else
    XLUrequestList = thisrec->next;

  for(assoc_desc = thisrec->assoc_desc, currrec = XLUrequestList;
      currrec != NULLXLUrequestRecord &&
      currrec->assoc_desc != assoc_desc;
      currrec = currrec->next)
    ;

  /* If no other requests are using this association descriptor, remove
     the associated callback */
  if (currrec == NULLXLUrequestRecord)
    XtRemoveInput(thisrec->input_id);

  XLUrequestCount--;
  XtFree((char *) thisrec);
} /* XLUrequestComplete */

/*****************************************************************************
 * XLUrequestInvoked()
 *
 * 
 *
 ****************************************************************************/

void XLUrequestInvoked(reqid,
		     type,
		     result_cb,
		     report_cb,
		     prim_widget,
		     objid,
		     prim_id,
		     action_id,
		     actlist)
     int reqid;
     QyRequestType type;
     DSResultCallback result_cb;
     DSReportCallback report_cb;
     Widget prim_widget;
     int objid;
     int prim_id;
     int action_id;
     XLUactionList actlist;
{
  XtInputId input_id;
  int assoc_desc;
  XLUrequestRecord newrec, currrec;

  /* Needs to be changed to get a list of ad\'s back, i.e. per task */
  assoc_desc = QyGetAssociation(reqid);

  /***************************************************
   *
   * If this association descriptor is not
   * already being used then add another
   * input callback to cover for it.
   *
   */

  for (currrec = XLUrequestList;
       currrec != NULLXLUrequestRecord
       && currrec->assoc_desc != assoc_desc;
       currrec = currrec->next)
    ;
    
  if (currrec == NULLXLUrequestRecord)
    input_id = XtAppAddInput(app_context,
			     assoc_desc,
			     (XtPointer) XtInputReadMask,
			     doQueryWork,
			     (XtPointer) NULL);

  else input_id = currrec->input_id;

  newrec = xlu_request_record_alloc();
  newrec->input_id = input_id;
  newrec->assoc_desc = assoc_desc;
  newrec->reqid = reqid;
  newrec->type = type;

  newrec->result_cb = result_cb;
  newrec->report_cb = report_cb;

  newrec->this_widget = prim_widget;
  newrec->action_id = action_id;
  newrec->objid = objid;
  newrec->prim_id = prim_id;
  newrec->actlist = actlist;

  newrec->next = XLUrequestList;
  XLUrequestList = newrec;

  XLUrequestCount++;
} /* XLUrequestInvoked */

/*****************************************************************************
 * XLUgetRequest()
 *
 * Get the request record for the given identifier.
 *
 ****************************************************************************/

XLUrequestRecord XLUgetRequest(reqid)
     int reqid;
{
  XLUrequestRecord record;

  for (record = XLUrequestList;
       record != NULLXLUrequestRecord && record->reqid != reqid;
       record = record->next)
    ;

  return record;
} /* XLUgetRequest */

/*****************************************************************************
 * doQueryWork()
 *
 * Poll query engine. Call report and/or result callbacks as necessary.
 *
 ****************************************************************************/

/* ARGSUSED */
static void doQueryWork(clientdata, ad_ptr, id_ptr)
     XtPointer clientdata;
     int *ad_ptr;
     XtInputId *id_ptr;
{
  int reqid, objid, prim_id;
  int action_id;
  XLUactionList actlist;
  Widget prim_widget;
  XLUrequestRecord thisrec;
  DSResultCallback result_func;
  DSReportCallback report_func;
  int *result_list = (int *) NULL,
            *report_list = (int *) NULL;
  int rqindex = 0, result_count, report_count;
  XLUwindowObject winobj;

  /* Poll the query engine. */
  QyPoll(&result_list, &result_count, &report_list, &report_count);

  /* Return if no results or reports returned. */
  if (result_count == 0 && report_count == 0)
    return;

  /**************************************************
   *
   * Process each returned report/result.
   * 
   */

  for (rqindex = 0; rqindex < result_count; rqindex++)
    {
      reqid = result_list[rqindex];
      
      for (thisrec = XLUrequestList;
	   thisrec != NULLXLUrequestRecord
	   && thisrec->reqid != reqid;
	   thisrec = thisrec->next)
	;
      
      /* This shouldn't happen */
      if (thisrec == NULLXLUrequestRecord)
	continue;
      
      action_id = thisrec->action_id;
      objid = thisrec->objid;
      prim_widget = thisrec->this_widget;
      actlist = thisrec->actlist;
      prim_id = thisrec->prim_id;
      result_func = thisrec->result_cb;
      report_func = thisrec->report_cb;

      /**************************************************
       *
       * Check if the request owner window has
       * closed. If so abort the request!
       * 
       */

      winobj = XLUgetWindowObject(objid);
      if (winobj == (XLUwindowObject) NULL)
	{
	  QyAbortRequest(reqid);
	  XLUrequestComplete(reqid);
	  
	  continue;
	}

      /* Call the result callback, and continue with action list. */
      (*result_func)(reqid, objid, action_id, actlist);

      doPrimitiveSensitivity(objid);
      callActionAux(prim_widget,
		    objid,
		    prim_id,
		    action_id,
		    actlist? actlist->next : NULLActionList);
      
      XLUrequestComplete(reqid);
    }

  /**************************************************
   *
   * Process reports.
   * 
   */

  for (rqindex = 0; rqindex < report_count; rqindex++)
    {
      reqid = report_list[rqindex];
      
      for (thisrec = XLUrequestList;
	   thisrec != NULLXLUrequestRecord
	   && thisrec->reqid != reqid;
	   thisrec = thisrec->next)
	;
      
      /* This shouldn't happen. */
      if (thisrec == NULLXLUrequestRecord)
	continue;

      /**************************************************
       *
       * Check if the request owner window has
       * closed. If so abort the request!
       * 
       */

      winobj = XLUgetWindowObject(objid);
      if (winobj == (XLUwindowObject) NULL)
	{
	  QyAbortRequest(reqid);
	  XLUrequestComplete(reqid);
	  
	  continue;
	}

      /* Call report callback (if present). */
      objid = thisrec->objid;

      report_func = thisrec->report_cb;
      if (report_func != NULL)
	(*report_func)(reqid, objid);

      doPrimitiveSensitivity(objid);
    }

  if (result_list != (int *) NULL)
    XtFree((char *) result_list);

  if (report_list != (int *) NULL)
    XtFree((char *) report_list);

  return;
} /* doQueryWork */
