#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/showentry.c,v 1.1 94/02/01 16:38:09 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/showentry.c,v 1.1 94/02/01 16:38:09 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  showentry.c - Display directory entries

*****************************************************************************/

#include "defs.h"

#include <X11/Xatom.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/ScrolledW.h>
#include <Xm/Label.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>

#include <signal.h>
#include <errno.h>

#include "query.h"
#include "quipu/common.h"

#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"
#include "requests.h"

#include "status.h"
#include "errview.h"
#include "showentry.h"

#include "mua_selection.h"

#ifdef  BSD42
#include <sys/wait.h>
#endif

#ifndef BINPATH
#define BINPATH "/usr/local/bin/"
#endif

/***************************************************
 *
 * Externals.
 *
 */

extern XLUobjectAction actions[];
extern Display *dpy;

/***************************************************
 *
 * Local functions.
 *
 */

static void doRead();
static void doReadSeeAlso();
static void DisplayAttribute();
static void AddDNButton();
static void DeletePhoto();
static void DisplayPhoto();

static void selectMailAddress();
static int LoseDUA();
static int ConvertDUA();
static void DisownDUA();

/***************************************************
 *
 * Audio only works for Sparc.
 *
 */

#if defined(sparc) && defined(SUNOS41)

static void AddAudioButton();
static void playAudio();
static void freeAudioData();

#endif // defined(sparc) && defined(SUNOS41)

/***************************************************
 *
 * Global storage.
 *
 */

XLUreadAttribute attrs_to_display = NULLReadAttribute;
Widget curr_selection_owner = NULLWidget, last_selection_owner = NULLWidget;

/***************************************************
 *
 * Local storage.
 *
 */

static char select_name[LINESIZE],
            select_dn[LINESIZE],
	    select_mail[LINESIZE],
	    select_phone[LINESIZE];

static XContext store_attr_cid;

/*****************************************************************************
 * initReadContexts()
 *
 * 
 *
 ****************************************************************************/

void initReadContexts()
{
  store_attr_cid = XUniqueContext();
} /* initReadContexts */

/*****************************************************************************
 * displayCurrentEntry()
 *
 * 
 *
 ****************************************************************************/

void displayCurrentEntry(prim_widget,
			 objid,
			 primid,
			 actid,
			 actlist)
     Widget prim_widget;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  WidgetList prim_insts;
  
  prim_insts = XLUgetPrimitiveList(objid, ENTRY_DISPLAY);
  if (prim_insts != (Widget *) NULL)
    {
      doRead(prim_widget, objid, primid, actid, actlist);
      XtFree((char *) prim_insts);
    }
} /* displayCurrentEntry */

/*****************************************************************************
 * gotReadResult()
 *
 * A query engine read has completed. Get the user result and display
 * it in the identified window object.
 *
 ****************************************************************************/

/* ARGSUSED */
void gotReadResult(reqid, objid, actid, actlist)
     int reqid;
     int objid;
     int actid;
     XLUactionList actlist;
{
  QyReadResult result;
  WidgetList prim_insts;
  char err_msg[LINESIZE], ufnstr[LINESIZE];
  String decerr;
  entryList rentry;

  XBell(dpy, 40);

  XLUstatusMessage(objid, "Read result received.");
  result = QyGetReadResult(reqid);

  XLUrequestComplete(reqid);
  doPrimitiveSensitivity(objid);

  if (result->entry == NULLAVList)
    /**************************************************
     *
     * Read failed. Set and display errors.
     * 
     */
    {
      if (result->errors != NULLError)
	{
	  QyPrintFriendlyDN(result->errors->baseobject, ufnstr);
	  decerr = QyPrintErrcode(result->errors->error_type);

	  (void) sprintf
	    (err_msg, "Couldn't read `%.24s..' because;\n%s", ufnstr, decerr);

	  XLUstatusMessage(objid, err_msg);
	}
      else
	XLUstatusMessage(objid, "Nothing found!");
    }
  else
    /**************************************************
     *
     * Read succeeded.
     * 
     */
    {
      
      prim_insts = XLUgetPrimitiveList(objid, ENTRY_DISPLAY);
      if (prim_insts != (Widget *) NULL)
	{
	  updateReadDisplay(objid,
			    prim_insts[0],
			    result->entry,
			    result->errors,
			    result->base_object);

	  rentry = NULLEntryList;
	  (void) dn_list_add(result->base_object,
			     &rentry,
			     result->entry,
			     NULLAttrT);

	  XLUsetWindowEntry(objid, rentry);
	  dn_list_free(&rentry);
	  
	  XtFree((char *) prim_insts);
	  XLUstatusMessage(objid, "");
	}
    }

  /**************************************************
   *
   * Check errors.
   * 
   */
  
  XLUsetWindowErrors(objid, result->errors);
  if (result->errors != NULLError)
    {
      result->errors = NULLError;
      updateErrorViewer(objid);
    }

  /**************************************************
   *
   * All done.
   * 
   */

  QyFreeReadResult(&result);
} /* gotReadResult */

/*****************************************************************************
 * updateReadDisplay()
 *
 * Display the given entry in ENTRY_DISPLAY primitive.
 *
 ****************************************************************************/

/* ARGSUSED */
void updateReadDisplay(objid, widget, aventry, errors, dn)
     int objid;
     Widget widget;
     QyAttrValList aventry;
     QyErrorList errors;
     String dn;
{
  Dimension namewidth = 0, height = 0, valwidth = 0;
  QyAttrValList curr_attr;
  Widget types, values, photo_widget, form,
         entry_label, tmpwidget, prev;
  Arg args[MAXARGS];
  AttributeType curr_type,
                text_or_type = AttrT_new("0.9.2342.19200300.100.1.2"),
                mail_type = AttrT_new("0.9.2342.19200300.100.1.3"),
                phone_type = AttrT_new("2.5.4.20");
  char buffer[LINESIZE],
       or_addr[LINESIZE],
       name[LINESIZE],
       phone[LINESIZE],
       mail_addr[LINESIZE];
  register XLUreadAttribute curr_display_attr;
  short dn_syntax, photo_syntax, audio_syntax;
  BOOLEAN photo_done = FALSE;
  XmString namestr, valstr, dnstr;
  XmFontList font;

#if defined(sparc) && defined(SUNOS41)
  QySoundData audio_data;
#endif
  
  or_addr[0] = name[0] = phone[0] = mail_addr[0]= '\0';
  QyPrintFriendlyDN(dn, name);

  dn_syntax = AttrT_new("2.5.4.34")->oa_syntax;
  photo_syntax = AttrT_new("0.9.2342.19200300.100.1.7")->oa_syntax;
  audio_syntax = AttrT_new("audio")->oa_syntax;

  /**************************************************
   *
   * Create NULL compound strings, These will
   * contain attribute type names and values.
   * 
   */

  namestr = XmStringCreateSimple("");
  valstr = XmStringCreateSimple("");

  XtSetArg(args[0], XmNworkWindow, &form);
  XtGetValues(widget, args, 1);

  types = XtNameToWidget(form, "readTypes");
  values = XtNameToWidget(form, "readValues");

  entry_label = XtNameToWidget(form, "entryName");
/*
  select_button = XtNameToWidget(form, "selectForMUA");
  */

  QyPrintFriendlyDN(dn, buffer);

  dnstr = XmStringCreateSimple(buffer);
  XtSetArg(args[0], XmNlabelString, dnstr);

  XtSetValues(entry_label, args, 1);
  XmStringFree(dnstr);

  /**************************************************
   *
   * Clear the old photo
   * 
   */

  photo_widget = XtNameToWidget(form, "photo");
  DeletePhoto(photo_widget);
  XtUnmanageChild(photo_widget);

  /**************************************************
   *
   * Remove buttons and text associated with old
   * active attributes.
   *
   */

  XtSetArg(args[0], XmNleftWidget, &prev);
  while ((tmpwidget = XtNameToWidget(form, "attrText")) != NULLWidget)
    {
      XtGetValues(tmpwidget, args, 1);
      
      XtUnmanageChild(tmpwidget);
      XtDestroyWidget(tmpwidget);
      
      XtUnmanageChild(prev);
      XtDestroyWidget(prev);
    }

  if ((tmpwidget = XtNameToWidget(form, "audioButton")) != NULLWidget)
    {
      XtUnmanageChild(tmpwidget);
      XtDestroyWidget(tmpwidget);
    }

  XtUnmanageChild(types);
  XtUnmanageChild(values);

  /******************************************************************
   *
   * Put all strings values into the correct PStream,
   * pairs,
   * Photos are displayed immediately,
   * Sounds are stored for later playing
   * Sounds stored under callback closure (for destroy and button)
   * Other file attributes freed immediately!
   *
   */

  prev = NULLWidget;

  for (curr_display_attr = attrs_to_display;
       curr_display_attr != NULLReadAttribute;
       curr_display_attr = curr_display_attr->next)
    {
      for (curr_attr = aventry;
	   curr_attr != NULLAVList;
	   curr_attr = curr_attr->next)
	{
	  curr_type = AttrT_new(curr_attr->attr_name->string);
	      
	  if (curr_type == curr_display_attr->type)
	    {
	      if (curr_type->oa_syntax == dn_syntax)
		/* Create a button and text pair for DN attributes */
		{
		  AddDNButton(curr_attr, objid, widget, &prev);
		}
	      else if (photo_done == FALSE && curr_attr->syntax ==photo_syntax)
		/* Display g3fax image */
		{
		  photo_done = TRUE;
		  DisplayPhoto(photo_widget, curr_attr->data.photo);
		}
#if defined(sparc) && defined(SUNOS41)
	      else if (curr_attr->syntax == audio_syntax)
		/* Sound button */
		{
		  audio_data = curr_attr->data.audio;
		  AddAudioButton(audio_data, widget, &prev);
		}
#endif // defined(sparc) && defined(SUNOS41)
	      else
		/* Display text printed attributes */
		{
		  DisplayAttribute(types,
				   &namestr,
				   &valstr,
				   curr_attr,
				   curr_display_attr->showtype,
				   &namewidth,
				   &valwidth,
				   &height);
		}
	    }

	  /***************************************************
	   *
	   * These attributes are saved for user selection
	   *
	   */

	  if (curr_type == text_or_type && *or_addr == '\0')
	    (void) strcpy(or_addr, curr_attr->val_list->string);
	  else if (curr_type == mail_type && *mail_addr == '\0')
	    (void) strcpy(mail_addr, curr_attr->val_list->string);
	  else if (curr_type == phone_type && *phone == '\0')
	    (void) strcpy(phone, curr_attr->val_list->string);
	}
    }

  /**************************************************
   *
   * Add strings in nameps and valps buffers
   * to text widgets, and set appropriate
   * dimensions.
   * 
   */

  XtSetArg(args[0], XmNfontList, &font);
  XtGetValues(types, args, 1);

  XmStringExtent(font, namestr, &namewidth, &height);
  namewidth += 8;
  height += 8;

  XtSetArg(args[0], XmNlabelString, namestr);
  XtSetArg(args[1], XmNwidth, namewidth);
  XtSetArg(args[2], XmNheight, height);
  XtSetArg(args[3], XmNtopCharacter, 0);
  XtSetValues(types, args, 4);

  XmStringExtent(font, valstr, &valwidth, &height);
  valwidth += 8;
  height += 8;

  XtSetArg(args[0], XmNlabelString, valstr);
  XtSetArg(args[1], XmNwidth, valwidth);
  XtSetArg(args[2], XmNheight, height);
  XtSetArg(args[3], XmNtopCharacter, 0);
  XtSetValues(values, args, 4);

  XmStringFree(namestr);
  XmStringFree(valstr);

  /**************************************************
   *
   * Re-enable update in text widgets and force 
   * re-layout.
   * 
   */

  XtManageChild(types);
  XtManageChild(values);
  XtManageChild(photo_widget);
} /* updateReadDisplay */

/*****************************************************************************
 * doRead()
 *
 * 
 *
 ****************************************************************************/

static void doRead(prim_widget, objid, primid, actid, actlist)
     Widget prim_widget;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  QyErrorCode read_state;
  int reqid;
  XLUwindowObject this_object;
  String strdn;

  this_object = XLUgetWindowObject(objid);
  if (this_object->current_entry == NULLEntryList)
    return;

  strdn = this_object->current_entry->string_dn;
  XLUstatusMessage(objid, "Reading entry. Please wait.");

  /**************************************************
   *
   * Initiate the read
   * 
   */

  if (strdn != NULLString)
    read_state = QyReadEntry(strdn, &reqid, NULLStrCell);
  else
    {
      XLUstatusMessage(objid, "No entry name given to read!");
      return;
    }

  XLUstatusMessage(objid, "Reading entry. Please Wait.");

  switch (read_state)
    {
    case QERR_bad_value_syntax:
      XBell(dpy, 40);
      XLUstatusMessage(objid, "Invalid name!");
      return;
      
    case QERR_internal_limit_reached:
      XBell(dpy, 40);
      XLUstatusMessage(objid, "Internal limit reached.");
      return;

    default:
      break;
    }

  /**************************************************
   *
   * Record request invocation
   * 
   */

  XLUrequestInvoked(reqid,
		  DS_READ,
		  gotReadResult,
		  (DSReportCallback) NULL,
		  prim_widget,
		  objid,
		  primid,
		  actid,
		  actlist == NULLActionList? actlist : actlist->next);
} /* doRead */

/*****************************************************************************
 * doSeeAlsoAction()
 *
 * 
 *
 ****************************************************************************/

void doSeeAlsoAction(prim_widget, objid, primid, actid, actlist)
     Widget prim_widget;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  WidgetList prim_insts;

  prim_insts = XLUgetPrimitiveList(objid, ENTRY_DISPLAY);

  if (prim_insts != (Widget *) NULL)
    {
      doReadSeeAlso(prim_widget, objid, primid, actid, actlist);

      XtFree((char *) prim_insts);
      XLUstatusMessage(objid, "Reading entry. Please wait.");
    }
} /* doSeeAlsoAction */

/*****************************************************************************
 * doReadSeeAlso()
 *
 * 
 *
 ****************************************************************************/

static void doReadSeeAlso(prim_widget, objid, primid, actid, actlist)
     Widget prim_widget;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  caddr_t data;
  int childid, tmplid;
  QyErrorCode read_state;
  int reqid;
  String strdn;

  if (primid != ENTRY_DISPLAY)
    return;

  if (XFindContext(dpy, XtWindow(prim_widget), store_attr_cid, &data)
      == XCNOENT)
    return;

  strdn = (String) data;

  /**************************************************
   *
   * Find the window object that'll receive output.
   * 
   */

  (void) XLUgetOutputTemplateID(actlist->outputs,
				XLUoneHit,
				&tmplid);

  (void) XLUfindOutputObject(objid,
			     tmplid,
			     actlist->mode,
			     &childid);

  /**************************************************
   *
   * Initiate the read
   * 
   */

  if (strdn != NULLString)
    read_state = QyReadEntry(strdn, &reqid, NULLStrCell);
  else
    {
      XLUstatusMessage(objid, "No entry given to read!");
      return;
    }

  XLUstatusMessage(objid, "Reading entry, please Wait.");

  switch (read_state)
    {
    case QERR_bad_value_syntax:
      XLUstatusMessage(objid, "Invalid entry name!");
      return;
      
    case QERR_internal_limit_reached:
      XLUstatusMessage(objid, "Internal limit reached.");
      return;

    default:
      break;
    }

  /**************************************************
   *
   * Record request invocation
   * 
   */

  XLUrequestInvoked(reqid,
		    DS_READ,
		    gotReadResult,
		    (DSReportCallback) NULL,
		    prim_widget,
		    childid,
		    primid,
		    actid,
		    actlist);
} /* doReadSeeAlso */

/*****************************************************************************
 * DisplayAttribute()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void DisplayAttribute(w,
			     namestr,
			     valstr,
			     this_attr,
			     showtype,
			     namewidth_ptr,
			     valwidth_ptr,
			     height_ptr)
     Widget w;
     XmString *namestr;
     XmString *valstr;
     QyAttrValList this_attr;
     XLUshowType showtype;
     Dimension *namewidth_ptr;
     Dimension *valwidth_ptr;
     Dimension *height_ptr;
{
  stringCell curr_val;
  String name, value, start, end;

  extern int ps_printf();

  /**************************************************
   *
   * Get and insert the name of the attribute
   * 
   */

  name = getAttributeName(AttrT_new(this_attr->attr_name->string));

  XLUappendXmString(namestr, name);
  XLUappendXmString(namestr, ":");

  /**************************************************
   *
   * Now insert the values
   * 
   */

  for (curr_val = this_attr->val_list;
       curr_val != NULLStrCell;
       curr_val = curr_val->next)
    {
      value = curr_val->string;

      /**************************************************
       *
       * Add component lines individually, checking
       * maximum text width and incrementing height
       * as well.
       * 
       */
      
      if ((end = index(value, '\n')) == NULLString)
	{
	  while (isspace(*value))
	    value++;
	  
	  XLUappendXmString(valstr, value);
	  XLUappendSeparatorXmString(valstr);
	  XLUappendSeparatorXmString(namestr);
	}
      else
	{
	  for (start = value;
	       (end = index(start, '\n')) != NULLString;
	       start = ++end)
	    {
	      *end = '\0';
	      
	      while (isspace(*start))
		start++;
	      
	      XLUappendXmString(valstr, start);
	      XLUappendSeparatorXmString(valstr);
	      XLUappendSeparatorXmString(namestr);
	    }
	  
	  for (end = start; !isnull(*end); end++)
	    ;
	  
	  while (isspace(*start))
	    start++;
	  
	  XLUappendXmString(valstr, start);
	  XLUappendSeparatorXmString(valstr);
	  XLUappendSeparatorXmString(namestr);
	}
    }

  XLUappendSeparatorXmString(valstr);
  XLUappendSeparatorXmString(namestr);
} /* DisplayAttribute */

/*****************************************************************************
 * AddDNButton()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void AddDNButton(this_attr, objid, widget, last_ptr)
     QyAttrValList this_attr;
     int objid;
     Widget widget;
     Widget *last_ptr;
{
  AttributeType curr_type;
  char buffer[LINESIZE];
  Widget aux_attr, aux_text, types, form;
  stringCell curr_value;
  String value;
  int count;
  Arg args[MAXARGS];
  XmString labelstr;

  aux_text = *last_ptr;
  aux_attr = NULLWidget;

  XtSetArg(args[0], XmNworkWindow, &form);
  XtGetValues(widget, args, 1);

  types = XtNameToWidget(form, "readTypes");

  curr_type = AttrT_new(this_attr->attr_name->string);

  for (curr_value = this_attr->val_list;
       curr_value != NULLStrCell;
       curr_value = curr_value->next)
    {
      value = XtNewString(curr_value->string);

      if (*value != '\0')
	{
	  /**************************************************
	   *
	   * Create button.
	   * 
	   */

	  count = 0;
	  
	  XtSetArg(args[count], XmNresizable, TRUE); count++;
	  XtSetArg(args[count], XmNtopOffset, 12); count++;
	  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;

	  if (aux_text == NULLWidget)
	    {
	      XtSetArg(args[count], XmNtopWidget, types); count++;
	    }
	  else
	    {
	      XtSetArg(args[count], XmNtopWidget, aux_text); count++;
	    }
	  
	  XtSetArg(args[count], XmNleftAttachment, XmATTACH_FORM);
	  	count++;

	  labelstr = XmStringCreateSimple(getAttributeName(curr_type));
	  XtSetArg(args[count], XmNlabelString, labelstr); count++;

	  aux_attr = XmCreatePushButton(form, "attrButton", args, count);
	  XmStringFree(labelstr);

	  XmAddTabGroup(aux_attr);
	  XtManageChild(aux_attr);

	  /**************************************************
	   *
	   * Store DN value and ID of read display.
	   * 
	   */

	  XLUsavePrimitiveContext(aux_attr, ENTRY_DISPLAY, ActionUndefined);

	  XLUaddContextEntry(aux_attr,
			     store_attr_cid,
			     (caddr_t) value,
			     XLUfreeStorage);

	  /**************************************************
	   *
	   * Text field containing UFN.
	   * 
	   */

	  QyPrintFriendlyDN(value, buffer);
	  count = 0;
	  
	  XtSetArg(args[count], XmNeditable, FALSE); count++;
	  XtSetArg(args[count], XmNvalue, buffer); count++;
	  
	  XtSetArg(args[count], XmNtopOffset, 12); count++;
	  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
	  
	  if (aux_text == NULLWidget)
	    {
	      XtSetArg(args[count], XmNtopWidget, types); count++;
	    }
	  else
	    {
	      XtSetArg(args[count], XmNtopWidget, aux_text); count++;
	    }
	  
	  XtSetArg(args[count], XmNleftOffset, 12); count++;
	  XtSetArg(args[count], XmNleftAttachment, XmATTACH_WIDGET); count++;

	  XtSetArg(args[count], XmNleftWidget, aux_attr); count++;
	  XtSetArg(args[count], XmNborderWidth, 0); count++;

	  XtSetArg(args[count], XmNresizable, TRUE); count++;
	  XtSetArg(args[count], XmNresizeHeight, TRUE); count++;
	  XtSetArg(args[count], XmNresizeWidth, TRUE); count++;
	  
	  *last_ptr = aux_text = XmCreateTextField(form,
						   "attrText",
						   args,
						   count);
	  XtManageChild(aux_text);
	}
    }
} /* AddDNButton */

/*****************************************************************************
 * selectMailAddress()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void selectMailAddress(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  String select_str = (String) closure;

  if (select_str == NULLString)
    return;

  last_selection_owner = curr_selection_owner;
  curr_selection_owner = w;

  /***************************************************
   *
   * Own the selection using MUA specific selection.
   *
   */

  (void) OwnMUA(w, ConvertDUA, LoseDUA, (caddr_t) select_str);
} /* SelectMailAddress */

/*****************************************************************************
 * LoseDUA()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static int LoseDUA(data)
     caddr_t data;
{
  XEvent event;
  String params = NULLCP;
      
  if (last_selection_owner != NULLWidget &&
      XtClass(last_selection_owner) == xmPushButtonWidgetClass)
    {
      XtCallActionProc(last_selection_owner, "unset", &event, &params, 0);
    }
  
  return 1;
} /* LoseDUA */

/*****************************************************************************
 * ConvertDUA()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static int ConvertDUA(data, name_ptr, phone_ptr, dn_ptr, or_ptr)
     caddr_t data;
     String *name_ptr;
     String *phone_ptr;
     String *dn_ptr;
     String *or_ptr;
{
  String start, end;

  *name_ptr = select_name;
  *phone_ptr = select_phone;
  *dn_ptr = select_dn;
  *or_ptr = select_mail;

  end = index((start = (String) data), '\n');
  *end = '\0';
  (void) strcpy(select_name, start);
  *end++ = '\n';
  
  end = index((start = end), '\n');
  *end = '\0';
  (void) strcpy(select_dn, start);
  *end++ = '\n';

  end = index((start = end), '\n');
  *end = '\0';
  (void) strcpy(select_phone, start);
  *end++ = '\n';

  start = end;
  (void) strcpy(select_mail, start);
  
  return 1;
} /* ConvertDUA */

/*****************************************************************************
 * DisownDUA()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void DisownDUA(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  Atom selection;
  
  selection = XInternAtom(dpy, MUA_ADDRESS, False);

  if (curr_selection_owner == w)
    {
      XtDisownSelection(w, selection, XtLastTimestampProcessed(dpy));
      curr_selection_owner = NULLWidget;
    }
  else if (last_selection_owner == w)
    last_selection_owner = NULLWidget;

  XtFree((char *) closure);
} /* DisownDUA */

#if defined(sparc) && defined(SUNOS41)

/*****************************************************************************
 * AddAudioButton()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void AddAudioButton(sound, widget, last_ptr)
     QySoundData sound;
     Widget widget;
     Widget *last_ptr;
{
  AttributeType audio_type;
  Widget button, form, types;
  int count;
  Arg args[MAXARGS];
  XmString labelstr;  

  XtSetArg(args[0], XmNworkWindow, &form);
  XtGetValues(widget, args, 1);

  types = XtNameToWidget(form, "readTypes");

  audio_type = AttrT_new("audio");
  count = 0;

  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;

  if (*last_ptr == NULLWidget)
    {
      XtSetArg(args[count], XmNtopWidget, types); count++;
    }
  else
    {
      XtSetArg(args[count], XmNtopWidget, *last_ptr); count++;
    }
  
  labelstr = XmStringCreateSimple(getAttributeName(audio_type));
  XtSetArg(args[count], XmNlabelString, labelstr); count++;
  
  *last_ptr = button = XmCreatePushButton(form, "audioButton", args, count);
  XmStringFree(labelstr);

  XmAddTabGroup(button);
  XtManageChild(button);

  XtAddCallback(button, XmNactivateCallback, playAudio, (XtPointer) sound);
} /* AddAudioButton */

/*****************************************************************************
 * playAudio()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void playAudio(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  QySoundData sound = (QySoundData) closure;
  int objid = XLUgetWindowObjectId(w);
  int pd[2];
  char buffer[LINESIZE], execvector[LINESIZE];

  int pid, childpid;
  SFP pstat;

#ifndef BSD42
int     status;
#else
union wait status;
#endif /* BSD42 */

  extern int fork(), pipe(), close(), dup2(),
         _exit(), execl(), read(), write(), fflush();

  if (pipe(pd) == -1)
    {
      XBell(dpy, 40);
      
      XLUstatusMessage(objid, "System error! Can't play sound");
      return;
    }

  pstat = signal(SIGPIPE, SIG_IGN);
  
  switch (childpid = fork())
    {
    case -1:
      
      (void) close (pd[1]);
      (void) close (pd[0]);
      (void) signal (SIGPIPE, pstat);
      
      XBell(dpy, 40);
      
      XLUstatusMessage(objid, "System error! Can't play sound");
      return;

    case 0:
      
      (void) signal (SIGPIPE, pstat);
      
      if (dup2(pd[0], 0) == -1)
	_exit (-1);

      (void) close (pd[0]);
      (void) close (pd[1]);
      
/*       (void) sprintf (execvector, "%splay", BINPATH); */
      (void) execvp("play", (char **) NULL);
      
      while (read (0, buffer, sizeof buffer) > 0)
	continue;
      
      (void) printf ("ERROR: can't execute '%s'", execvector);
      (void) fflush (stdout);

      /* safety catch */
      _exit (-1);

      /* NOTREACHED */

    default:

      (void) close (pd[0]);

      XLUstatusMessage(objid, "Play audio invoked");
      
      if (write(pd[1], (char *) sound->bytes, sound->length) != sound->length)
	{
	  (void) close (pd[1]);
	  (void) signal (SIGPIPE, pstat);

	  XBell(dpy, 40);

	  XLUstatusMessage(objid, "System error! Can't play sound");
	  return;
	}

      (void) close (pd[1]);

      while ((pid = wait(&status)) != NOTOK && childpid != pid)
	continue;
      
      (void) signal (SIGPIPE, pstat);
      
      return;
    }
} /* playAudio */

/*****************************************************************************
 * freeAudioData()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void freeAudioData(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  QySoundData sound = (QySoundData) closure;
  
  XtFree((char *) sound->bytes);
  XtFree((char *) sound);
} /* FreeAudioBytes */

#endif /* defined(sparc) && defined(SUNOS41) */

/*****************************************************************************
 * DeletePhoto()
 *
 * Clear the given photo widget and free it\'s current background pixmap.
 *
 ****************************************************************************/

static void DeletePhoto(w)
     Widget w;
{
  Pixmap old_pixmap;
  Arg args[MAXARGS];
  int count;
  Screen *screen = XtScreen(w);

  XtSetArg(args[0], XmNbackgroundPixmap, &old_pixmap);
  XtGetValues(w, args, 1);

  count = 0;
  XtSetArg(args[count], XmNbackgroundPixmap, XmUNSPECIFIED_PIXMAP); count++;

  XtSetArg(args[count], XmNborderWidth, (Dimension) 0); count++;
  XtSetArg(args[count], XmNborderColor, WhitePixelOfScreen(screen)); count++;

  XtSetArg(args[count], XmNinternalWidth, (Dimension) 0); count++;
  XtSetArg(args[count], XmNinternalHeight, (Dimension) 0); count++;

  XtSetValues(w, args, count);

  if (old_pixmap != XmUNSPECIFIED_PIXMAP)
    {
      count = 0;
      XtSetArg(args[count], XmNbackgroundPixmap, XmUNSPECIFIED_PIXMAP);count++;
      XtSetValues(w, args, count);
      
      XFreePixmap(dpy, old_pixmap);
    }
} /* DeletePhoto */


/*****************************************************************************
 * DisplayPhoto()
 *
 * Display the given X bitmap as a background in the given widget.
 *
 ****************************************************************************/

static void DisplayPhoto(w, data)
     Widget w;
     QyPhotoData data;
{
  Pixmap photo_pixmap;
  Screen *screen = XtScreen(w);
  Arg args[MAXARGS];
  int count;
		  
  photo_pixmap = XCreatePixmapFromBitmapData
    (dpy,
     XtWindow(w),
     (char *) data->bytes,
     (int) data->width,
     (int) data->height,
     BlackPixelOfScreen(screen),
     WhitePixelOfScreen(screen),
     DefaultDepthOfScreen(screen));
		  
  count = 0;
  XtSetArg(args[count], XmNwidth, (Dimension) data->width); count++;
  XtSetArg(args[count], XmNheight, (Dimension) data->height); count++;
		  
  XtSetArg(args[count], XmNborderWidth, 1); count++;
  XtSetArg(args[count], XmNbackgroundPixmap, photo_pixmap); count++;
		  
  XtSetArg(args[count], XmNborderColor, BlackPixelOfScreen(screen)); count++;
  XtSetArg(args[count], XmNmarginWidth, (Dimension) 1);	count++;

  XtSetArg(args[count], XmNmarginHeight, (Dimension) 1); count++;
  XtSetValues(w, args, count);
} /* DisplayPhoto */

