#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/update2.c,v 1.1 94/02/01 16:37:51 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/update2.c,v 1.1 94/02/01 16:37:51 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  update2.c - Modify operations (add, update, delete)

*****************************************************************************/

#include "defs.h"
#include <X11/Xatom.h>

#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/MenuShell.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>

#include "query.h"
#include "quipu/common.h"

#include "windows.h"
#include "requests.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"

#include "update1.h"
#include "status.h"
#include "errview.h"

/***************************************************
 *
 * Externals.
 *
 */

extern Display *dpy;
extern Widget toplevel;
extern void updateFieldData();

/***************************************************
 *
 * Local functions.
 *
 */

static void submitUpdates();
static void addEntry();

static void gotAddResult();
static void gotNameCheckResult();
static void gotUpdateResult();
static void gotDeleteResult();

static QyModifyAttr getNewFieldValues();
static QyModifyAttr getUpdates();

/***************************************************
 *
 * Local storage.
 *
 */

static char err_msg[LINESIZE];

/***************************************************
 *
 * Global storage.
 *
 */

XLUentryClass entry_class_list = NULLEntryClass;
XLUattributeGroup attr_group_list = NULLAttrGroup;
XLUattrTemplate attr_template_list = NULLAttrTemplate;
String base_entry_class = NULLString;

/*****************************************************************************
 * submitModifications()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void submitModifications(pw)
     Widget pw;
{
  BOOLEAN changes;
  XLUupdateState state;
  int objid = XLUgetWindowObjectId(pw);

  getUpdateState(pw, &changes, &state);
  switch (state)
    {
    case Modifying:

      submitUpdates(pw, objid);
      break;

    case Composing:

      addEntry(pw, objid);
      break;
    }

  doPrimitiveSensitivity(objid);
} /* submitModificationsCallback */

/*****************************************************************************
 * submitUpdates()
 *
 * 
 *
 ****************************************************************************/

static void submitUpdates(modify, objid)
     Widget modify;
     int objid;
{
  modifyEntry mentry;
  QyModifyAttr updates;
  XLUwindowObject object;
  QyErrorList errors;
  int reqid;
  XLUupdateContext modstate;
  String strdn;

  object = XLUgetWindowObject(objid);

  /**************************************************
   *
   * Get a list of updated attributes.
   * 
   */

  modstate = (XLUupdateContext) XLUgetPrimitiveData(modify);
  mentry = modstate->modentry;

  updates = getUpdates(mentry);
  if (updates == NULLModifyAttr)
    {
      XBell(dpy, 40);
      XLUstatusMessage(objid, "No changes to make!");
      return;
    }

  /* Get baseobject */
  if (object->current_entry != NULLEntryList)
    strdn = object->current_entry->string_dn;
  else
    strdn = NULLString;

  /* Initiate update request */
  errors = QyUpdateEntry(&reqid, strdn, NULLString, updates);
  if (errors != NULLError)
    {
      QyErrorList curr_error;
      
      XBell(dpy, 40);
      
      for (curr_error = errors;
           curr_error != NULLError;
           curr_error = curr_error->next)
        if (curr_error->error_type != QERR_no_mods_supplied &&
            curr_error->error_type != QERR_no_name_changes)
          break;

      if (curr_error != NULLError)
        {
          if (curr_error->ds_message != NULLCP)
            XLUstatusMessage(objid, curr_error->ds_message);
          else
            XLUstatusMessage(objid,
                             QyPrintErrcode(curr_error->error_type));

          XLUsetWindowErrors(objid, errors);
        }
      else
        {
          XLUstatusMessage(objid, "No modifications to make!");
          QyFreeErrorList(&errors);
          XLUsetWindowErrors(objid, NULLError);
        }

      return;
    }

  /**************************************************
   *
   * Record request invocation.
   * 
   */

  XLUrequestInvoked(reqid,
		  MODIFY_ENTRY,
		  gotUpdateResult,
		  (DSReportCallback) NULL,
		  modify,
		  objid,
		  MODIFY,
		  0,
		  NULLActionList);

  XBell(dpy, 40);
  XLUstatusMessage(objid, "Saving changes, please wait.");
} /* submitUpdates */

/*****************************************************************************
 * addEntry()
 *
 * 
 *
 ****************************************************************************/

static void addEntry(pw, objid)
     Widget pw;
     int objid;
{
  int count;
  Arg args[MAXARGS];
  XLUentryClass class;
  modifyEntry mod_entry;
  QyModifyAttr mod_attr = NULLModifyAttr, curr_attr,
             top_attr = NULLModifyAttr, additions;
  QyModifyValue mod_value = NULLModifyValue, curr_value;
  int reqid;
  String entry_name;
  Widget name_field;
  QyErrorList errors;
  XLUupdateContext modstate;

  modstate = (XLUupdateContext) XLUgetPrimitiveData(pw);
  mod_entry = modstate->modentry;
  class = modstate->class;

  if (class == NULLEntryClass || mod_entry == NULLModifyEntry)
    return;

  /**************************************************
   *
   * Default attributes (those not displayed).
   * 
   */

  for (curr_attr = mod_entry->undisplayed;
       curr_attr != NULLModifyAttr;
       curr_attr = curr_attr->next)
    {
      mod_attr = modify_attr_alloc();
      
      mod_attr->to_modify = FALSE;
      mod_attr->attr_type = curr_attr->attr_type;
      
      mod_attr->next = top_attr;
      top_attr = mod_attr;

      for (curr_value = curr_attr->values, mod_attr->values = NULLModifyValue;
	   curr_value != NULLModifyValue;
	   curr_value = curr_value->next)
	{
	  mod_value = modify_value_alloc();

	  mod_value->next = mod_attr->values;
	  mod_attr->values = mod_value;

	  mod_value->value = XtNewString(curr_value->value);
	  mod_value->new_value = NULLString;

	  mod_value->status = curr_value->status;
	}
    }

  /**************************************************
   *
   * Get edited values.
   * 
   */

  for (curr_attr = top_attr;
       curr_attr->next != NULLModifyAttr;
       curr_attr = curr_attr->next)
    ;
     
  additions = getUpdates(mod_entry);

  if (curr_attr != NULLModifyAttr)
    {
      curr_attr->next = additions;
      additions = top_attr;
    }
  
 /***************************************************
   *
   * Get entry name.
   *
   */

  name_field = XtNameToWidget(pw, "entryNameEdit");

  count = 0;
  XtSetArg(args[count], XmNvalue, &entry_name); count++;
  XtGetValues(name_field, args, count);

  /***************************************************
   *
   * Initiate add request.
   *
   */

  errors = QyAddEntry(&reqid,
		  NULLString,
		  entry_name,
		  class->rdn_type,
		  additions);

  if (errors != NULLError)
    {
      XBell(dpy, 40);

      if (errors->ds_message != NULLString)
	XLUstatusMessage(objid, errors->ds_message);
      else
	XLUstatusMessage(objid, QyPrintErrcode(errors->error_type));
      
      XLUsetWindowErrors(objid, errors);
    }
  else
    {
      XLUstatusMessage(objid, "Adding entry. Please wait...");
    }

  /***************************************************
   *
   * Record request invocation.
   *
   */
  
  XLUrequestInvoked(reqid,
		  ADD_ENTRY,
		  gotAddResult,
		  (DSReportCallback) NULL,
		  pw,
		  objid,
		  MODIFY,
		  ActionUndefined,
		  NULLActionList);
} /* addEntry */

/*****************************************************************************
 * gotAddResult()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void gotAddResult(reqid, objid, actid, actlist)
     int reqid;
     int objid;
     int actid;
     XLUactionList actlist;
{
  QyAddResult result;
  WidgetList instances;
  Widget name_edit;
  XLUupdateContext modstate;
  Arg args[MAXARGS];
  int count;
  char new_name[LINESIZE];
  entryList mentry;

  XBell(dpy, 40);

  result = get_add_result(reqid);
  if (result->was_successful == TRUE)
    {
      XLUstatusMessage(objid, "Entry added succesfully");
      instances = XLUgetPrimitiveList(objid, MODIFY);

      modstate = (XLUupdateContext) XLUgetPrimitiveData(instances[0]);
      updateFieldData(modstate->modentry);

      /* Set the new entry to be the window\'s current entry */
      mentry = NULLEntryList;
      dn_list_add(result->baseobject, &mentry, NULLAVList, NULLAttrT);

      XLUsetWindowEntry(objid, mentry);
      dn_list_free(&mentry);
      
      /* Entry has been added, now switch to "modify" mode */
      setUpdateState(instances[0], TRUE, Modifying);

      /* Print new DN in name edit field */
      QyPrintFriendlyDN(result->baseobject, new_name);
      name_edit = XtNameToWidget(instances[0], "entryNameEdit");

      count = 0;
      XtSetArg(args[count], XmNvalue, new_name); count++;
      XtSetValues(name_edit, args, count);

      XtFree((char *) instances);
    }
  else
    {
      (void) sprintf(err_msg,
                     "Add operation failed because;\n%s",
                     QyPrintErrcode(result->errors->error_type));

      XLUstatusMessage(objid, err_msg);
    }

  XLUsetWindowErrors(objid, result->errors);
  result->errors = NULLError;

  XLUrequestComplete(reqid);
  QyFreeAddResult(&result);
} /* gotAddResult */

/*****************************************************************************
 * gotUpdateResult()
 *
 *
 *
 *
 ****************************************************************************/

/* ARGSUSED */
static void gotUpdateResult(reqid, objid, actid, actlist)
     int reqid;
     int objid;
     int actid;
     XLUactionList actlist;
{
  QyUpdateResult result;
  WidgetList instances;
  XLUupdateContext modstate;
  XBell(dpy, 40);

  result = QyGetUpdateResult(reqid);
  if (result->was_successful == TRUE)
    {
      XLUstatusMessage(objid, "Changes saved succesfully");
      instances = XLUgetPrimitiveList(objid, MODIFY);

      modstate = (XLUupdateContext) XLUgetPrimitiveData(instances[0]);
      updateFieldData(modstate->modentry);

      XtFree((char *) instances);
    }
  else
    {
      (void) sprintf(err_msg,
                     "Add operation failed because:\n%s",
                     QyPrintErrcode(result->errors->error_type));

      XLUstatusMessage(objid, err_msg);
    }

  XLUsetWindowErrors(objid, result->errors);
  result->errors = NULLError;

  XLUrequestComplete(reqid);
  QyFreeUpdateResult(&result);
} /* gotUpdateResult */

/*****************************************************************************
 * getNewFieldValues()
 *
 * Update the value contained in the given field
 *
 ****************************************************************************/

static QyModifyAttr getNewFieldValues(field)
     modifyField field;
{
  QyModifyAttr attr;
  QyModifyValue value;
  Arg args[MAXARGS];
  int count, changecount = 0;
  String strval, tidystr;
  BOOLEAN haveNew, haveOld;

  attr = field->this_attr;
  attr->to_modify = FALSE;

  while (field != NULLModifyField)
    {
      value = field->this_value;

      if (field->changed == TRUE)
	{
	  /**************************************************
	   *
	   * Get updated value.
	   * 
	   */
	  
	  if (field->edit != NULLWidget)
	    {
	      count = 0;
	      XtSetArg(args[count], XmNvalue, &strval); count++;
	      XtGetValues(field->edit, args, count);
	      
	      strval = XtNewString(strval);
	      tidystr = XtNewString(TidyString(strval));
	      
	      XtFree(strval);

	      strval = tidystr;
	      if (isnull(*strval))
		{
		  XtFree(strval);
		  strval = NULLString;
		}
	    }
	  else
	    strval = value->new_value;

	  value->new_value = strval;
	      
	  /**************************************************
	   *
	   * Set the value update flag.
	   * 
	   */

	  haveNew = (strval == NULLString? FALSE : TRUE);
	  haveOld = (value->value == NULLString? FALSE : TRUE);

	  if (haveOld == TRUE && haveNew == TRUE)
	    {
	      if (lexequ(value->new_value, value->value) == 0)
		{
		  /**************************************************
		   *
		   * New and old values are the same!
		   * 
		   */
		  {
		    XtFree(value->new_value);
		    value->new_value = NULLString;
		    value->status = QMVunchanged;
		  }
		}
	      else
		{
		  changecount++;
		  value->status = QMVupdated;
		}
	    }
	  else if (haveOld == FALSE && haveNew == TRUE)
	    {
	      changecount++;
	      value->status = QMVnew;
	    }
	  else if (haveOld == TRUE && haveNew == FALSE)
	    {
	      changecount++;
	      value->status = QMVdeleted;
	    }
	  else
	    value->status = QMVunchanged;
	}
      else
	/**************************************************
	 *
	 * No changes flagged.
	 * 
	 */
	{
	  value->status = QMVunchanged;
	}

      field = field->next;
    }

  if (changecount > 0)
    {
      attr->to_modify = TRUE;
      return attr;
    }
  else
    return NULLModifyAttr;
} /* getNewFieldValues */

/*****************************************************************************
 * getUpdate()
 *
 * Get updates from a modifyEntry.
 *
 ****************************************************************************/

static QyModifyAttr getUpdates(mentry)
     modifyEntry mentry;
{
  modifyField field;
  modifyGroup group;
  QyModifyAttr first = NULLModifyAttr, last = NULLModifyAttr, attr;

  for (group = mentry->groups; group != NULLModifyGroup; group = group->next)
    {
      field = group->fields;
      while (field != NULLModifyField)
	{
	  modifyField attrfield, nextfield;

	  /**************************************************
	   *
	   * Get a list of fields containing values
	   * from the same attribute.
	   * 
	   */

	  for (attrfield = field, attr = field->this_attr;
	       attrfield->next != NULLModifyField &&
	       attrfield->next->this_attr == attr;
	       attrfield = attrfield->next)
	    ;

	  nextfield = attrfield->next;
	  attrfield->next = NULLModifyField;

	  /**************************************************
	   *
	   * Get updated field sequence (if any updates
	   * made).
	   */

	  attr = getNewFieldValues(field);
	  if (attr != NULLModifyAttr)
	    {
	      if (first == NULLModifyAttr)
		first = last = attr;
	      else
		{
		  last->next = attr;
		  last = attr;
		}
	    }

	  /* Loop advance */
	  field = attrfield->next = nextfield;
	}
    }

  return first;
} /* getUpdates */

/*****************************************************************************
 * deleteEntry()
 *
 * Delete an entry.
 *
 ****************************************************************************/

/* ARGSUSED */
void deleteEntry(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  int objid;
  XLUwindowObject object;
  WidgetList instances;
  QyErrorList errors;
  int reqid;
  String strdn;
  
  objid = XLUgetWindowObjectId(w);
  object = XLUgetWindowObject(objid);

  instances = XLUgetPrimitiveList(objid, MODIFY);

  /**************************************************
   *
   * Invoke delete operation.
   * 
   */

  /* Get the Dn of entry to delete */
  if (object->current_entry != NULLEntryList)
    strdn = object->current_entry->string_dn;
  else
    strdn = NULLString;

  /* Invoke delete request */
  errors = QyDeleteEntry(&reqid, strdn);
  if (errors != NULLError)
    {
      XBell(dpy, 40);

      if (errors->ds_message != NULLString)
	XLUstatusMessage(objid, errors->ds_message);
      else
	XLUstatusMessage(objid, QyPrintErrcode(errors->error_type));
      
      XLUsetWindowErrors(objid, errors);
    }
  else
    {
      XLUstatusMessage(objid, "Deleting entry. Please wait...");
    }

  /***************************************************
   *
   * Record request invocation.
   *
   */
  
  XLUrequestInvoked(reqid,
		  DELETE_ENTRY,
		  gotDeleteResult,
		  (DSReportCallback) NULL,
		  instances[0],
		  objid,
		  MODIFY,
		  ActionUndefined,
		  NULLActionList);

  XtFree((char *) instances);
} /* deleteEntry */

/*****************************************************************************
 * gotDeleteResult()
 *
 * Received a delete result/error.
 *
 ****************************************************************************/

/* ARGSUSED */
static void gotDeleteResult(reqid, objid, actid, actlist)
     int reqid;
     int objid;
     int actid;
     XLUactionList actlist;
{
  QyDeleteResult result;
  WidgetList instances;
  char errmsg[LINESIZE];
  entryList lentry;

  extern char *local_dit;
  extern char username[];

  XBell(dpy, 40);

  result = QyGetDeleteResult(reqid);
  if (result->was_successful == TRUE)
    {
      XLUpopupMessage("Entry deleted OK.");
      instances = XLUgetPrimitiveList(objid, MODIFY);

      lentry = NULLEntryList;
      (void) dn_list_add(local_dit, &lentry, NULLAVList, NULLAttrT);

      XLUsetWindowEntry(objid, lentry);
      dn_list_free(&lentry);

      displayEntryTemplate(instances[0],
			   objid,
			   MODIFY,
			   ActionUndefined,
			   NULLActionList);

      XtFree((char *) instances);
    }
  else
    /* Delete failed */
    {
      (void) sprintf(errmsg,
		     "Entry removal failed because:\n%s",
		     QyPrintErrcode(result->errors->error_type));

      XLUstatusMessage(objid, errmsg);
    }

  XLUsetWindowErrors(objid, result->errors);
  result->errors = NULLError;

  XLUrequestComplete(reqid);
  free_delete_result(&result);
} /* gotDeleteResult */
