#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/widgets.c,v 1.1 94/02/01 16:38:22 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/widgets.c,v 1.1 94/02/01 16:38:22 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  widgets.c - Widget creation functions.

*****************************************************************************/

#include "defs.h"
#include "windows.h"
#include "widgets.h"
#include "callbacks.h"
#include "configure.h"
#include "layout.h"
#include "actions.h"
#include "xutil.h"
#include "showlist.h"

#include "formsrch.h"
#include "update1.h"
#include "update2.h"
#include "searchlog.h"

#include "dn_list.h"
#include "ufsearch.h"

#include "y.tab.h"

#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/Shell.h>
 
#include <Xm/ScrolledW.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/MenuShell.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/RowColumn.h>

/***************************************************
 *
 * Externals.
 *
 */

extern Display *dpy;
extern XLUobjectAction actions[];

extern QyTargetClass target_classes[];
extern int target_class_num;

/***************************************************
 *
 * Local declarations.
 *
 */

static XtActionsRec action_table[] =
{
  {"doAction", (XtActionProc) callActionAsAction},
  {"XLUwmEvent", (XtActionProc) XLUwmEvent},
  {"pruneSearch", (XtActionProc) XLUpruneSearch},
};

/*****************************************************************************
 * XLUloadActions()
 *
 * Initialize window context values and read in core XLU actions.
 *
 ****************************************************************************/

void XLUloadActions(app_context)
     XtAppContext app_context;
{
  extern Widget toplevel;
  XtAppAddActions(app_context, action_table, XtNumber(action_table));
} /* XLUloadActions */

/*****************************************************************************
 * XLUmakeButton()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeButton(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Widget this_widget;
  int count;
  int  width, height;
  String name = template->name;
  XmString cstr = (XmString) NULL;

  count = argcount;
  if (template->bitmap_file != NULLString)
    {
      if (get_dims_of_bitmap_file(template->bitmap_file, &width, &height)
	  == TRUE)
	{
	  XtSetArg(topargs[count], XmNwidth, (Dimension) width); count++;
	  XtSetArg(topargs[count], XmNheight, (Dimension) height); count++;

	  cstr = XmStringCreateSimple("");
	  XtSetArg(topargs[count], XmNlabelString, cstr); count++;
	}
    }
  else
    {
      if (template->height != 0)
	{
	  XtSetArg(topargs[count], XmNheight, template->height); count++;
	}
      
      if (template->width != 0)
	{
	  XtSetArg(topargs[count], XmNwidth, template->width); count++;
	}

      if (template->label != NULLString)
	{
	  XtSetArg(topargs[count],
		   XmNlabelString,
		   XmStringCreateSimple(template->label));
	  count++;
	}
    }

  XtSetArg(topargs[count], XmNresizable, FALSE); count++;
  this_widget = XmCreatePushButton(parent,
				   (name == NULLString? "button" : name), 
				   topargs,
				   count);
  
  if (cstr != (XmString) NULL)
    XmStringFree(cstr);

  XtManageChild(this_widget);
  XmAddTabGroup(this_widget);

  return this_widget;
} /* XLUmakeButton */

/*****************************************************************************
 * XLUmakeUFNdialog()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeUFNdialog(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Arg args[MAXARGS];
  int count;
  Widget this_widget, label, dialog;

  count = argcount;
  XtSetArg(topargs[count], XmNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  this_widget = XmCreateForm(parent, "moveto", topargs, count);
  XtManageChild(this_widget);

  label = XmCreateLabel(this_widget, "movetoLabel", args, 0);
  XtManageChild(label);

  XtSetArg(args[0], XmNleftWidget, label);
  dialog = XmCreateTextField(this_widget, "movetoDialog", args, 1);

  XtSetArg(args[0], XmNtopOffset, 0);
  XtSetValues(dialog, args, 1);

  XtManageChild(dialog);
  XmAddTabGroup(this_widget);

  return this_widget;
} /* XLUmakeUFNdialog */

/*****************************************************************************
 * XLUmakeStatusBar()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeStatusBar(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  int count;
  Widget this_widget;
  XmString cstr = (XmString) NULL;

  count = argcount;

  XtSetArg(topargs[count], XmNborderWidth, 1); count++;

  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  cstr = XmStringCreateSimple("");
  XtSetArg(topargs[count], XmNlabelString, cstr); count++;
  XtSetArg(topargs[count], XmNrecomputeSize, TRUE); count++;

  this_widget = XmCreateLabel(parent, "statusBar", topargs, count);
  XtManageChild(this_widget);

  XmStringFree(cstr);
  return this_widget;
} /* XLUmakeStatusBar */

/*****************************************************************************
 * XLUmakeLabel()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeLabel(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  int count;
  Widget this_widget;
  String name = template->name;
  int width, height;
  XmString cstr = (XmString) NULL;

  count = argcount;
  XtSetArg(topargs[count], XmNresizable, TRUE); count++;

  if (template->bitmap_file != NULLString)
    {
      if (get_dims_of_bitmap_file(template->bitmap_file,&width,&height) ==TRUE)
	{
	  XtSetArg(topargs[count], XmNwidth, width); count++;
	  XtSetArg(topargs[count], XmNheight, height); count++;

	  cstr = XmStringCreateSimple("");
	  XtSetArg(topargs[count], XmNlabelString, cstr); count++;
	}
    }
  else
    {
      if (template->height != 0)
	{
	  XtSetArg(topargs[count], XmNheight, template->height); count++;
	}
      
      if (template->width != 0)
	{
	  XtSetArg(topargs[count], XmNwidth, template->width); count++;
	}

      if (template->label != NULLString)
	{
	  XtSetArg(topargs[count],
		   XmNlabelString,
		   XmStringCreateSimple(template->label));
	  count++;
	}
    }

  XtSetArg(topargs[count], XmNresize, FALSE); count++;
  XtSetArg(topargs[count], XmNborderWidth, 0); count++;

  this_widget = XmCreateLabel(parent,
			      (name == NULLString? "titleBar" : name),
			      topargs,
			      count);

  if (cstr != (XmString) NULL)
    XmStringFree(cstr);

  XtManageChild(this_widget);
  return this_widget;
} /* XLUmakeLabel */

/*****************************************************************************
 * XLUmakeEntryViewer()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeEntryViewer(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Arg args[MAXARGS];
  int count;
  Widget this_widget;
  Widget types, values, form, name;
  XmString cstr = (XmString) NULL;

  count = argcount;

  XtSetArg(topargs[count], XmNscrollingPolicy, XmAUTOMATIC); count++;
  XtSetArg(topargs[count], XmNvisualPolicy, XmCONSTANT); count++;
  XtSetArg(topargs[count], XmNscrollBarDisplayPolicy, XmSTATIC); count++;
  XtSetArg(topargs[count], XmNresizable, FALSE); count++;

  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  this_widget = XmCreateScrolledWindow(parent, "readDisplay", topargs, count);
  XtManageChild(this_widget);

  count = 0;
  XtSetArg(args[count], XmNresizable, TRUE); count++;
  XtSetArg(args[count], XmNresize, TRUE); count++;

  form = XmCreateForm(this_widget, "readForm", args, count);
  XtManageChild(form);
  XmAddTabGroup(form);

  count = 0;

  XtSetArg(args[count], XmNresizable, TRUE); count++;
  XtSetArg(args[count], XmNrecomputeSize, TRUE); count++;
  
  cstr = XmStringCreateSimple("");
  XtSetArg(args[count], XmNlabelString, cstr); count++;
  XtSetArg(args[count], XmNleftAttachment, XmATTACH_FORM); count++;
  XtSetArg(args[count], XmNtopAttachment, XmATTACH_FORM); count++;

  name = XmCreateLabel(form, "entryName", args, count);
  XtManageChild(name);

/*
  count = 0;

  XtSetArg(args[count], XmNleftAttachment, XmATTACH_FORM); count++;
  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNtopWidget, name); count++;

  select_button = XmCreatePushButton(form, "selectForMUA", args, count);
  XtManageChild(select_button);
  XmAddTabGroup(select_button);
*/

  count = 0;

  XtSetArg(args[count], XmNborderWidth, 0); count++;
  XtSetArg(args[count], XmNalignment, XmALIGNMENT_BEGINNING); count++;

  XtSetArg(args[count], XmNlabelString, cstr); count++;
  XtSetArg(args[count], XmNresizable, TRUE); count++;

  XtSetArg(args[count], XmNrecomputeSize, TRUE); count++;
  XtSetArg(args[count], XmNleftAttachment, XmATTACH_FORM); count++;

  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNtopWidget, name); count++;

  types = XmCreateLabel(form, "readTypes", args, count);
  XtManageChild(types);

  count = 0;
  XtSetArg(args[count], XmNborderWidth, 0); count++;

  XtSetArg(args[count], XmNlabelString, cstr); count++;
  XtSetArg(args[count], XmNalignment, XmALIGNMENT_BEGINNING); count++;

  XtSetArg(args[count], XmNrecomputeSize, TRUE); count++;
  XtSetArg(args[count], XmNresizable, TRUE); count++;

  XtSetArg(args[count], XmNleftAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNleftWidget, types); count++;

  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNtopWidget, name); count++;

  values = XmCreateLabel(form, "readValues", args, count);
  XtManageChild(values);

  count = 0;

  XtSetArg(args[count], XmNborderWidth, 0); count++;
  XtSetArg(args[count], XmNlabelString, cstr); count++;

  XtSetArg(args[count], XmNrecomputeSize, FALSE); count++;
  XtSetArg(args[count], XmNresizable, TRUE); count++;

  XtSetArg(args[count], XmNleftAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNleftWidget, values); count++;

  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNtopWidget, name); count++;

  XtManageChild(XmCreateLabel(form, "photo", args, count));

  XmStringFree(cstr);

  XtManageChild(this_widget);
  XmAddTabGroup(this_widget);

  return this_widget;
} /* XLUmakeEntryViewer */

/*****************************************************************************
 * XLUmakeFormDialog()
 *
 * 
 *
 ****************************************************************************/

Widget XLUmakeFormDialog(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Arg args[MAXARGS];
  int count, cindex;
  Widget this_widget, pulldown, menu, item, topitem;
  primInfo prim_data;
  XLUprimitiveAction action_list = template->action_list;
  XmString cstr;

  /* Create parent form */
  count = argcount;

  if (template->height != 0)
 {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  XtSetArg(topargs[count], XmNhorizontalSpacing, 10); count++;
  XtSetArg(topargs[count], XmNverticalSpacing, 10); count++;

  this_widget = XmCreateForm(parent, "searchGroup", topargs, count);
  XtManageChild(this_widget);

 /***************************************************
  *
  * Create menu.
  *
  */

  pulldown = XmCreatePulldownMenu(this_widget, "XLUtypesMenu", args, 0); 

  /***************************************************
   *
   * Keep data for changes in search type.
   *
   */

  prim_data = prim_info_alloc();
  prim_data->object_id = objid;

  if (action_list != (XLUprimitiveAction) NULL)
    prim_data->action_id = action_list->prim_action_id;
  else
    prim_data->action_id = ActionUndefined;

  prim_data->primitive_id = LOOKUP;

  /***************************************************
   *
   * Create menu buttons.
   *
   */

  topitem = NULLWidget;
  for (cindex = 0; cindex < target_class_num; cindex++)
    {
      /***************************************************
       *
       * Create menu item corresponding to a search type.
       *
       */

      cstr = XmStringCreateSimple(target_classes[cindex]->label);
      XtSetArg(args[0], XmNlabelString, cstr);

      item = XmCreatePushButtonGadget(pulldown,
				      target_classes[cindex]->label,
				      args,
				      1);

      XmStringFree(cstr);
      XtManageChild(item);

      if (topitem == NULLWidget)
	topitem = item;
      
      XtAddCallback(item,
		    XmNactivateCallback,
		    ChangeSearchType,
		    (XtPointer) prim_data);
    }

  XtAddCallback(pulldown,
		XmNdestroyCallback,
		FreePrimInfo,
		(XtPointer) prim_data);

  /**************************************************
   *
   * Create pulldown menu.
   * 
   */
  
  cstr = XmStringCreateSimple("Search type:");
  XtSetArg(args[0], XmNlabelString, cstr);
  XtSetArg(args[1], XmNsubMenuId, pulldown);

  menu = XmCreateOptionMenu(this_widget, "typeButton", args, 2);
  XmStringFree(cstr);

  XmAddTabGroup(menu);
  XtManageChild(menu);

  /***************************************************
   *
   * Create the search edit fields.
   *
   */

  SearchForType(topitem, (WidgetList) NULL);
  count = 0;

  if (template->height != 0)
    {
      XtSetArg(args[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XmNwidth, template->width); count++;
    }

  XtSetValues(this_widget, args, count);
  XmAddTabGroup(this_widget);

  return this_widget;
} /* XLUmakeFormDialog */

/*****************************************************************************
 * XLUmakeListViewer()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeListViewer(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  int count;
  Widget this_widget;
  String name = template->name;
  
  count = argcount;

  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  XtSetArg(topargs[count], XmNscrollBarDisplayPolicy, XmSTATIC); count++;
  XtSetArg(topargs[count], XmNresizable, TRUE); count++;
  XtSetArg(topargs[count], XmNborderWidth, 0); count++;

  this_widget = XmCreateScrolledList(parent,
				     (name == NULLString? "listForm" : name), 
				     topargs,
				     count);

  XtManageChild(XtParent(this_widget));
  XtManageChild(this_widget);

  XtAddCallback(this_widget,
		XmNsingleSelectionCallback,
		selectListEntry,
		(XtPointer) NULL);

  XmAddTabGroup(XtParent(this_widget));
  return this_widget;
} /* XLUmakeListViewer */

/*****************************************************************************
 * XLUmakeHelpViewer()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeHelpViewer(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Arg args[MAXARGS];
  int count;
  Widget this_widget, help_text;

  count = argcount;

  XtSetArg(topargs[count], XmNscrollingPolicy, XmAUTOMATIC); count++;
  XtSetArg(topargs[count], XmNvisualPolicy, XmCONSTANT); count++;
  XtSetArg(topargs[count], XmNscrollBarDisplayPolicy, XmSTATIC); count++;
  XtSetArg(topargs[count], XmNresizable, FALSE); count++;

  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  this_widget = XmCreateScrolledWindow(parent, "helpDisplay", topargs, count);
  XtManageChild(this_widget);

  count = 0;

  XtSetArg(args[count], XmNvalue, ""); count++;
  XtSetArg(args[count], XmNeditable, FALSE); count++;

  XtSetArg(args[count], XmNcursorPositionVisible, TRUE); count++;
  XtSetArg(args[count], XmNresizable, TRUE); count++;

  XtSetArg(args[count], XmNresizeWidth, TRUE); count++;
  XtSetArg(args[count], XmNresizeHeight, TRUE); count++;

  XtSetArg(args[count], XmNshadowThickness, 0); count++;
  XtSetArg(args[count], XmNborderWidth, 0); count++;

  help_text = XmCreateText(this_widget, "helpText", args, count);
  XtManageChild(help_text);

  return this_widget;
} /* XLUmakeHelpViewer */

/*****************************************************************************
 * XLUmakeModifyDialog()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeModifyDialog(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Arg args[MAXARGS];
  int count;
  Widget this_widget, modify_view;
  Widget entry_label, entry_name;
  Widget group_menu;
  Widget previous, next, rowcol, label, editform;
  XmString cstr;

  extern void submitModificationsCallbacks(),
              addEntryCallback(),
              deleteEntryCallback();

  /***************************************************
   *
   * The top level form.
   *
   */

  count = argcount;

  XtSetArg(topargs[count], XmNresizable, TRUE); count++;
  XtSetArg(topargs[count], XmNresizePolicy, XmRESIZE_ANY); count++;

  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  XtSetArg(topargs[count], XmNhorizontalSpacing, 8); count++;
  XtSetArg(topargs[count], XmNverticalSpacing, 8); count++;

  this_widget = XmCreateForm(parent, "modifyForm", topargs, count);
  XtManageChild(this_widget);
  XmAddTabGroup(this_widget);

  /***************************************************
   *
   * Label.
   *
   */

/*  XtSetArg(args[0], XmNtopWidget, commit_button);*/
  entry_label = XmCreateLabel(this_widget, "entryLabel", args, 0);

  XtManageChild(entry_label);

  /***************************************************
   *
   * Entry name edit field.
   *
   */

  XtSetArg(args[0], XmNeditable, FALSE);
  XtSetArg(args[1], XmNleftWidget, entry_label);
/*   XtSetArg(args[2], XmNtopWidget, commit_button); */

  entry_name = XmCreateTextField(this_widget, "entryNameEdit", args, 2);

  XmAddTabGroup(entry_name);
  XtManageChild(entry_name);

  /***************************************************
   *
   * Attribute group stuff.
   *
   */

  rowcol = XmCreatePulldownMenu(this_widget, "menu", args, 0);

  XtSetArg(args[0], XmNtopWidget, entry_name);
  cstr = XmStringCreateSimple("Information group");
  XtSetArg(args[1], XmNlabelString, cstr);
  XtSetArg(args[2], XmNsubMenuId, rowcol);

  group_menu = XmCreateOptionMenu(this_widget, "groupOptionMenu", args, 3);
  XmStringFree(cstr);

  XmAddTabGroup(entry_name);
  XtManageChild(group_menu);

  label = XmOptionButtonGadget(group_menu);
  XtSetArg(args[0], XmNrecomputeSize, FALSE);
  XtSetValues(label, args, 1);

  /***************************************************
   *
   * Group selection stuff.
   *
   */

  XtSetArg(args[0], XmNtopWidget, group_menu);
  XtSetArg(args[1], XmNtopOffset, 10);

  previous = XmCreatePushButton(this_widget, "previousGroup", args, 2);

  XmAddTabGroup(previous);
  XtManageChild(previous);

  XtAddCallback(previous,
		XmNactivateCallback,
		displayPreviousGroup,
		(XtPointer) NULL);

  XtSetArg(args[0], XmNleftWidget, previous);
  XtSetArg(args[1], XmNtopWidget, group_menu);
  XtSetArg(args[2], XmNtopOffset, 10);

  next = XmCreatePushButton(this_widget, "nextGroup", args, 3);

  XmAddTabGroup(next);
  XtManageChild(next);

  XtAddCallback(next, XmNactivateCallback, displayNextGroup, (XtPointer) NULL);

  /***************************************************
   *
   * Viewport for attribute edit form pages.
   *
   */

  count = 0;

  XtSetArg(args[count], XmNscrollingPolicy, XmAUTOMATIC); count++;
  XtSetArg(args[count], XmNvisualPolicy, XmCONSTANT); count++;

  XtSetArg(args[count], XmNscrollBarDisplayPolicy, XmSTATIC); count++;
  XtSetArg(args[count], XmNtopWidget, previous); count++;

  modify_view = XmCreateScrolledWindow(this_widget,
				       "modifyWindow",
				       args,
				       count);
  XtManageChild(modify_view);

  /***************************************************
   *
   * Top level form in viewport,
   * individual edit fields/dialogs will be
   * contained in sub forms.
   *
   */

  XtSetArg(args[0], XmNresizable, TRUE);
  XtSetArg(args[1], XmNresizePolicy, XmRESIZE_ANY);
  editform = XmCreateForm(modify_view, "modifyViewForm", args, 2);

  XmAddTabGroup(next);
  XtManageChild(editform);

  return this_widget;
} /* XLUmakeModifyDialog */

/*****************************************************************************
 * XLUmakeErrorViewer()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeErrorViewer(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Arg args[MAXARGS];
  int count;
  Widget this_widget, view_form;
  XmString cstr;

  count = argcount;

  XtSetArg(topargs[count], XmNscrollingPolicy, XmAUTOMATIC); count++;
  XtSetArg(topargs[count], XmNvisualPolicy, XmCONSTANT); count++;

  XtSetArg(topargs[count], XmNscrollBarDisplayPolicy, XmSTATIC); count++;
  XtSetArg(topargs[count], XmNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

  this_widget = XmCreateScrolledWindow(parent,
				       "errorWindow",
				       topargs,
				       count);

  XtManageChild(this_widget);

  XtSetArg(args[0], XmNresizable, TRUE);
  view_form = XmCreateForm(this_widget, "errorViewForm", args, 1);
  XtManageChild(view_form);

  count = 0;
  
  cstr = XmStringCreateSimple("No Errors");
  XtSetArg(args[count], XmNborderWidth, 0); count++;

  XtSetArg(args[count], XmNresizable, TRUE); count++;
  XtSetArg(args[count], XmNlabelString, cstr); count++;

  XtManageChild(XmCreateLabel(view_form, "errorViewLabel", args, count));
  XmStringFree(cstr);

  return this_widget;
} /* XLUmakeErrorViewer */

/*****************************************************************************
 * XLUmakeLogViewer()
 *
 * Create a primitive that logs progress for the identified request. 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget XLUmakeLogViewer(parent, objid, template, topargs, argcount)
     Widget parent;
     int objid;
     XLUlayoutObject template;
     Arg topargs[];
     int argcount;
{
  Widget listbox;
  int count;

  /* List box displays entries currently being searched under. */
  count = argcount;
  if (template->height != 0)
    {
      XtSetArg(topargs[count], XmNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(topargs[count], XmNwidth, template->width); count++;
    }

/*
  XtSetArg(topargs[count], XmNscrollingPolicy, XmAUTOMATIC); count++;
  XtSetArg(topargs[count], XmNvisualPolicy, XmCONSTANT); count++;
  XtSetArg(topargs[count], XmNselectionPolicy, XmSINGLE_SELECT); count++;
*/

  XtSetArg(topargs[count], XmNscrollBarDisplayPolicy, XmSTATIC); count++;
  XtSetArg(topargs[count], XmNresizable, TRUE); count++;
  listbox = XmCreateScrolledList(parent, "logProgressList", topargs, count);

  XtManageChild(listbox);

  XtAddCallback(listbox,
		XmNbrowseSelectionCallback,
		ItemSelected,
		(XtPointer) NULL);

  XtAddCallback(XtParent(listbox),
		XmNdestroyCallback,
		LogWindowCleanUp,
		(XtPointer) NULL);

  /* All done. */
  return XtParent(listbox);
} /* XLUmakeLogViewer */

