#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/xdutil.c,v 1.1 94/02/01 16:38:25 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/xdutil.c,v 1.1 94/02/01 16:38:25 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  xdutil.c - Assorted procedures

*****************************************************************************/

#include "defs.h"
#include "xdutil.h"
#include "quipu/attr.h"
#include "configure.h"
#include "status.h"
#include "read.h"

/***************************************************
 *
 * Global storage.
 *
 */

XLUattributeName attr_name_list = NULLAttributeName;

/*****************************************************************************
 * getAttributeName()
 *
 * Get "friendly" attribute name.
 *
 ****************************************************************************/

String getAttributeName(attr_type)
     AttributeType attr_type;
{
  register XLUattributeName names;
  
  for (names = attr_name_list;
       names != NULLAttributeName && names->type != attr_type;
       names = names->next)
    ;

  if (names != NULLAttributeName && names->name != NULLString)
    return names->name;

  return attr2name(attr_type, OIDPART);
}

/*****************************************************************************
 * getAttributeOfName()
 *
 * Get an AttributeType keyed with it's "friendly" name.
 *
 ****************************************************************************/

AttributeType getAttributeOfName(name)
     String name;
{
  register XLUattributeName names;
  
  for (names = attr_name_list;
       names != NULLAttributeName && lexequ(names->name, name) != 0;
       names = names->next)
    ;

  if (names != NULLAttributeName && names->name != NULLString)
    return names->type;

  return AttrT_new(name);
} /* getAttributeOfName */

/*****************************************************************************
 * xluWarning()
 *
 *  
 *
 ****************************************************************************/

void xluWarning(msg)
     String msg;
{
  char err_msg[LINESIZE];
  (void) sprintf(err_msg, "Error : %s\n", msg);
  XLUpopupMessage(err_msg);
} /* xluWarning */

/*****************************************************************************
 * xluFatal()
 *
 * 
 *
 ****************************************************************************/

void xluFatal(error)
     String error;
{
  char err_msg[LINESIZE];
  extern void exit();

  (void) sprintf(err_msg, "Fatal error : %s\n", error);
  XLUpopupMessage(err_msg);

  exit(1);
} /* xluFatal */

/*****************************************************************************
 * XLUgetListValues()
 *
 * Get the values indicated in the XLUlistValue list from a sequence of
 * attributes.
 *
 ****************************************************************************/

stringCell XLUgetListValues(avlist, select)
     QyAttrValList avlist;
     XLUlistValue select;
{
  BOOLEAN got_it;
  AttributeType valtype, seltype;
  XLUlistValue currsel;
  register QyAttrValList currval;
  stringCell values, copystr, attrs;

  values = NULLStrCell;
  for (currsel = select; currsel!=(XLUlistValue) NULL; currsel = currsel->next)
    {
      for (currval = avlist; currval != NULLAVList; currval = currval->next)
	{
	  if (currval->attr_name == NULLStrCell)
	    continue;
	  
	  got_it = FALSE;
	  valtype = str2AttrT(currval->attr_name->string);

	  for (attrs = currsel->attrs;
	       attrs != NULLStrCell;
	       attrs = attrs->next)
	    {
	      seltype = str2AttrT(attrs->string);
	      if (seltype == valtype)
		{
		  got_it = TRUE;
		  break;
		}
	    }

	  if (got_it == TRUE)
	    break;
	}
      
      if (got_it == TRUE && currval->val_list != NULLStrCell)
	{
	  switch (currsel->type)
	    {
	    case ListAll:

	      /* Copy all values, then seperate with a <CR> */
	      if (values != NULLStrCell)
		SeqAddString("\n", &values);

	      for (copystr = currval->val_list, &values;
		   copystr != NULLStrCell;
		   copystr = copystr->next)
		SeqAddString(copystr->string, &values);

	      SeqAddString("\n", &values);
	      break;

	    default:
	      /* case ListOne: */

	      /* Arbitrarily, copy first value in list */
	      SeqAddString(currval->val_list->string, &values);
	      break;
	    }
	}
      else if (currsel->type == ListAll)
	/* Selected attribute not contained in entry */
	{
	  if (values != NULLStrCell)
	    SeqAddString("\n", &values);

	  /* To take care of Motif list widget bug */
/*	  SeqAddString("                                                                                ", &values); */
	  SeqAddString("\n", &values);
	}
    }

  return values;
} /* XLUgetListValues */

/*****************************************************************************
 * XLUgetEntryValues()
 *
 * Get the values indicated in the string list from a sequence of
 * attributes.
 *
 ****************************************************************************/

stringCell XLUgetEntryValues(avlist, select)
     QyAttrValList avlist;
     stringCell select;
{
  BOOLEAN got_it;
  AttributeType valtype, seltype;
  register stringCell currsel;
  stringCell values, copystr;

  values = NULLStrCell;
  while (avlist != NULLAVList)
    {
      if (avlist->attr_name == NULLStrCell)
	continue;

      got_it = FALSE;
      valtype = str2AttrT(avlist->attr_name->string);
      for (currsel = select; currsel != NULLStrCell; currsel = currsel->next)
	{
	  seltype = str2AttrT(currsel->string);
	  if (seltype == valtype)
	    {
	      got_it = TRUE;
	      break;
	    }
	}
      
      if (got_it == TRUE && avlist->val_list != NULLStrCell)
	{
	  /* Arbitrarily, copy first value in list */
	  SeqAddString(avlist->val_list->string, &values);
	}

      avlist = avlist->next;
    }

  return values;
} /* XLUgetEntryValues */

